//================================================================
//Texture
sampler sampler0_ : register(s0);

//================================================================
//--------------------------------
struct PS_INPUT
{
	float4 diffuse : COLOR0;  
	float2 texCoord : TEXCOORD0; 
	float2 vPos : VPOS; 
};

//--------------------------------
struct PS_OUTPUT
{
    float4 color : COLOR0;
};


//================================================================
//--------------------------------
PS_OUTPUT PsMonotone( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;

	float4 colorTexture = tex2D(sampler0_, In.texCoord);

	float4 colorDiffuse = In.diffuse;

	float4 color = colorTexture * colorDiffuse;

	Out.color.rgb = ( color.r + color.g + color.b ) * 0.3333f;
	Out.color.a = color.a;

	return Out;
}


//================================================================
//--------------------------------
//technique
technique TecMonotone
{
	pass P0
	{
		PixelShader = compile ps_3_0 PsMonotone();
	}
}

